module behavioralModel

open util/graph[node]

abstract sig node{
	isRoot: one IsRoot,
	child: set node
}

abstract sig IsRoot{}
one sig Yes extends IsRoot{}
one sig No extends IsRoot{}

// Simple Path : A path from node ni to nj is simple if no node appears more than once, except possibly the first and last nodes are the same
sig path{	
	first: one node,
//	nodes: set node,
	edges: node->node,
}{
	first.isRoot = Yes

//	rootedAt[edges, first]
	first in edges.node

//	functional[edges,node]
	all x: node | lone x.edges

	edges in child
	
//	weaklyConnected[edges]
//	no x: dom[edges]| 
	no x: edges.node| x !in first.*(edges)
//	all x: node-first | x in ran[edges] implies x in dom[edges]

//	no leaveNode[edges].child 

}

// Prime Path : A simple path that does not appear as a proper subpath of any other simple path
sig primePath extends path{}{
	// the leave node of a primePath has no child to be a longest possible path
	no leaveNode[edges].child 

}

fun leaveNode [r: node->node] : one node {
	r[node]-r.node
}

pred show{}
run show

